unit Icontray;

(*
  Sample project that uses thunking and the WOW interface to
  utilize the Windows 95 system tray.  This package includes
  the following units:

      CALL32NT.PAS
      LONGNAME.PAS
      W32FILOP.PAS

  In addition to the Windows 95 system tray capability, the
  units above provide complete Windows 95 long file and
  directory name support.

  Compile and run and then click on the InsertBtn to add the
  application icon (any icon is okay) to the Win 95 system
  tray.  The program will minimize and the icon will appear
  on the tray.  Left-click on the icon to restore the app.
  Right-click on the icon to display the pop-up menu.

  It works!

  Have fun!

  John Newlin
  CIS 71535,665
*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, LongName, W32FilOp, StdCtrls,
  Buttons, Menus;

type
  TTestForm = class(TForm)
    CloseBtn: TBitBtn;
    InsertBtn: TButton;
    TrayPop: TPopupMenu;
    ItemA1: TMenuItem;
    ItemB1: TMenuItem;
    Label1: TLabel;
    procedure CloseBtnClick(Sender: TObject);
    procedure InsertBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ItemA1Click(Sender: TObject);
    procedure ItemB1Click(Sender: TObject);
  private
    DoRemove : boolean;
    NRec : TNotifyIconData;
    LongHandle : longint;
    procedure TrayNotify(var Msg:TMessage); Message WM_User;
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

Const
  ProgId : longint = 44; {or whatever you like because it's a
                          unique identifer}

procedure TTestForm.TrayNotify(var Msg:TMessage);
var
  p : TPoint;
begin
  {lParam specifies the mouse message generated by the system
   and wParam specifies the unique identifer}
  case Msg.lParam of
    wm_MouseMove : if Visible then
      begin
        GetCursorPos(P);
        Label1.Caption := 'Mouse x/y = '+inttostr(p.x)+'/'+
                          inttostr(p.y);
      end;
    wm_LButtonDown :
      begin
        Application.restore; {in case minimized}
        Show;
      end;
    wm_RButtonDown :
      begin
        GetCursorPos(P);
        TrayPop.PopUp(p.x,p.y-100);
      end;
  end;
end;

procedure TTestForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TTestForm.InsertBtnClick(Sender: TObject);
begin
  FillChar(NRec,SizeOf(NRec),0);
  LongHandle := Handle32(Handle); {convert to 32-bit handle}
  With NRec do
    begin
      cbSize := Sizeof(NRec);
      wnd := LongHandle;
      uid := ProgId;
      uflags :=  nif_icon or nif_message or  nif_tip;
      ucallbackmessage := WM_USER;
      hIcon := Application.Icon.Handle;
      StrCopy(szTip,'Test hint here');
    end;
  if W32Shell_NotifyIcon(Nim_Add,@NRec,id_W32Shell_NotifyIcon) then
    begin
      DoRemove := true;
      Hide;
      InsertBtn.Enabled := false;
    end else ShowMessage('Ooops!  The call failed!');

end;

procedure TTestForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if DoRemove then
    W32Shell_NotifyIcon(Nim_Delete,@NRec,id_W32Shell_NotifyIcon);
end;

procedure TTestForm.ItemA1Click(Sender: TObject);
begin
  ShowMessage('Selected item A');
end;

procedure TTestForm.ItemB1Click(Sender: TObject);
begin
  ShowMessage('Selected item B');
end;

end.
